## dolfinx-mpc 0.10.1

=== cpp/CMakeLists.txt ===
#------------------------------------------------------------------------------
# Top level CMakeLists.txt file for DOLFINX_MPC
cmake_minimum_required(VERSION 3.21)

#------------------------------------------------------------------------------
# Set project name and version number
project(DOLFINX_MPC VERSION "0.10.1")

#------------------------------------------------------------------------------
# General configuration
# Make sure CMake uses the correct DOLFINConfig.cmake for tests and demos
set(CMAKE_PREFIX_PATH ${CMAKE_PREFIX_PATH} ${CMAKE_CURRENT_BINARY_DIR}/dolfinx_mpc)

#------------------------------------------------------------------------------
# configurable options for how we want to build

include(FeatureSummary)

option(BUILD_SHARED_LIBS "Build DOLFINX_MPC with shared libraries." ON)
add_feature_info(BUILD_SHARED_LIBS BUILD_SHARED_LIBS "Build DOLFINX_MPC with shared libraries.")

option(CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath." ON)
add_feature_info(CMAKE_INSTALL_RPATH_USE_LINK_PATH CMAKE_INSTALL_RPATH_USE_LINK_PATH "Add paths to linker search and installed rpath.")

# Check for required package DOLFINX
find_package(DOLFINX 0.10.0.0 REQUIRED)
set_package_properties(DOLFINX PROPERTIES TYPE REQUIRED
    DESCRIPTION "New generation Dynamic Object-oriented Library for - FINite element computation"
    URL "https://github.com/FEniCS/dolfinx"
    PURPOSE "Main dependency of library")
feature_summary(WHAT ALL)


# Installation of DOLFIN_MPC library

# Declare the library (target)

add_library(dolfinx_mpc)
target_compile_features(dolfinx_mpc PUBLIC cxx_std_20)

# dolfinx gives us transitive dependency on mpi, petsc, basix, ufcx
# without us needing to reimplement detection/dependency
target_link_libraries(dolfinx_mpc PUBLIC dolfinx)


#------------------------------------------------------------------------------
include(GNUInstallDirs)

#------------------------------------------------------------------------------

install(FILES dolfinx_mpc.h  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dolfinx_mpc COMPONENT Development)

install(FILES assemble_utils.h mpi_utils.h ContactConstraint.h utils.h MultiPointConstraint.h SlipConstraint.h PeriodicConstraint.h assemble_matrix.h assemble_vector.h lifting.h mpc_helpers.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/dolfinx_mpc COMPONENT Development)
# Add source files to the target
target_sources(dolfinx_mpc PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}/utils.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/assemble_matrix.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/assemble_vector.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/assemble_utils.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/mpi_utils.cpp
  )

# Set target include location (for build and installed)
target_include_directories(dolfinx_mpc PUBLIC
                           $<INSTALL_INTERFACE:include>
                           "$<BUILD_INTERFACE:${DOLFINX_MPC_SOURCE_DIR};${DOLFINX_MPC_SOURCE_DIR}/dolfinx_mpc>")

# Set target properties
set_target_properties(dolfinx_mpc PROPERTIES
  VERSION ${DOLFINX_MPC_VERSION}
  SOVERSION ${DOLFINX_MPC_VERSION_MAJOR}.${DOLFINX_MPC_VERSION_MINOR})


# Add version to definitions (public)
target_compile_definitions(dolfinx_mpc PUBLIC DOLFINX_MPC_VERSION="${DOLFINX_MPC_VERSION}")


#------------------------------------------------------------------------------
# Install dolfinx library and header files
install(TARGETS dolfinx_mpc
  EXPORT DOLFINX_MPCTargets
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT RuntimeExecutables
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RuntimeLibraries
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development
  )

# Generate DOLFINTargets.cmake
install(EXPORT DOLFINX_MPCTargets DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dolfinx_mpc)

include(CMakePackageConfigHelpers)

configure_package_config_file(${DOLFINX_MPC_SOURCE_DIR}/DOLFINX_MPCConfig.cmake.in
${CMAKE_BINARY_DIR}/dolfinx_mpc/DOLFINX_MPCConfig.cmake
INSTALL_DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dolfinx_mpc)

# Install CMake helper files
install(
  FILES
  ${CMAKE_BINARY_DIR}/dolfinx_mpc/DOLFINX_MPCConfig.cmake
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/dolfinx_mpc
  COMPONENT Development)

#------------------------------------------------------------------------------

=== debian/changelog ===
dolfinx-mpc (0.10.1-1) unstable; urgency=medium

  * New upstream release
  * update debian/watch to latest v5 GitHub template
  * Standards-Version: 4.7.3

 -- Drew Parsons <dparsons@debian.org>  Sun, 01 Feb 2026 12:11:17 +0100

dolfinx-mpc (0.10.0-2) unstable; urgency=medium

  * upload dolfinx-mpc 0.10 to unstable

 -- Drew Parsons <dparsons@debian.org>  Mon, 22 Dec 2025 08:51:22 +0100

=== debian/control ===
Source: dolfinx-mpc
Section: libs
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>,
           Francesco Ballarin <francesco.ballarin@unicatt.it>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 libbasix-dev (>= 0.10.0~), python3-basix,
 libdolfinx-dev (>= 1:0.10.0~), python3-dolfinx,
 python3-all-dev,
 python3-pytest,
 python3-setuptools,
 dh-sequence-python3,
 pybuild-plugin-pyproject,
 python3-dolfinx-real,
 python3-gmsh <!nocheck>,
 python3-mpi4py,
 python3-nanobind (>= 2.0.0~),
 python3-numpy,
 python3-petsc4py,
 python3-scikit-build-core,
 python3-scipy,
 python3-ufl
Standards-Version: 4.7.3
Homepage: https://github.com/jorgensd/dolfinx_mpc
Vcs-Browser: https://salsa.debian.org/science-team/fenics/dolfinx-mpc
Vcs-Git: https://salsa.debian.org/science-team/fenics/dolfinx-mpc.git

Package: libdolfinx-mpc-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libdolfinx-mpc0.10 (= ${binary:Version}),
 ${misc:Depends},
Description: Multi-point constraints with FEniCS-X
 This library contains an add-on to FEniCSx enabling the possibilities
 of enforce multi-point constraints. This can be used to for instance
 enforce slip conditions strongly, or apply periodic boundaries..

Package: libdolfinx-mpc0.10
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Multi-point constraints with FEniCS-X
 This library contains an add-on to FEniCSx enabling the possibilities
 of enforce multi-point constraints. This can be used to for instance
 enforce slip conditions strongly, or apply periodic boundaries..

Package: python3-dolfinx-mpc
Architecture: any
Depends: libdolfinx-mpc0.10 (= ${binary:Version}),
 python3-dolfinx-real,
 ${python3:Depends},
 ${shlibs:Depends},
 ${misc:Depends},
Description: Multi-point constraints with FEniCS-X
 This library contains an add-on to FEniCSx enabling the possibilities
 of enforce multi-point constraints. This can be used to for instance
 enforce slip conditions strongly, or apply periodic boundaries..

=== debian/watch ===
Version: 5
Template: GitHub
Dist: https://github.com/jorgensd/dolfinx_mpc
